<?php

class pluginBluditSearch extends Plugin {
	
	public function init()
	{
		// Fields and default values for the database of this plugin
		$this->dbFields = array(
			'search_key'=> 's'
		);
	}

	// Method called on the settings of the plugin on the admin area
	public function form()
	{
		global $Language;
		$html = '<div>';
		$html .= '<label>'.$Language->get('Search Key').'</label>';
		$html .= '<input id="jsamountOfItems" name="search_key" type="text" value="'.$this->getValue('search_key').'">';
		$html .= '<span class="tip">'.$Language->get('This Key will be used for Search Queries').'</span>';
		$html .= '</div>';

		return $html;
	}	

	public function siteBodyBegin(){
		
		global $dbPages;
		global $pages;
		global $content;
		global $Url, $Page, $Site, $keyword,$Language;
		
		$keyword = $Url->parameter("s");
		$type = ($Url->parameter("search_type")) ? $Url->parameter("search_type") : "post";
		
		$post_source = array();
		$searched_post = array();
		
		if($keyword) {

			$post_list_keys = $this->filter_search($keyword,$type);
		
			$html = "<div class=\"btn btn-success\">";
			$html .= "<h2>".$Language->g("Search results for")." <q>$keyword</q> - ".count($post_list_keys)." ".$Language->g("results found")."</h2>";
			$html .= "</div>";
			
			echo $html;	
			
			if(count($post_list_keys)){
				
				foreach($post_list_keys as $post){					
					$page_data = buildPage($post);
					if ($page_data!==false) {
						array_push($searched_post, $page_data);
					}
				}
			}
			
			$content = $searched_post;

			$itemsPerPage = $Site->itemsPerPage();
			
			$current_page = Paginator::currentPage();
			
			$amountOfItems = count($post_list_keys);
			
			// Append Keyword into Paginator
			Paginator::set("append","&s=$keyword&search_type=$type");
			
			// Amount of items
			Paginator::set('amountOfItems', $amountOfItems);
			// Amount of pages
			$amountOfPages = (int) max(ceil($amountOfItems / $itemsPerPage), 1);
			Paginator::set('amountOfPages', $amountOfPages);
			
			// Slice into Pages		
			$content = array_slice($searched_post,(($current_page - 1) * $itemsPerPage), $itemsPerPage);
			
		}
		
	}
	
	public function filter_search($keyword,$type = "post")
	{
		global $dbPages;
		
		$post_list = array();
		$post_keys = array();
		
		$post_keys = $dbPages->getPublishedDB($onlyKeys=true);
		
		foreach($post_keys as $post){
			
			$post_list[] = buildPage($post);
			
		}
		
		switch ($type) {
			case "post":
				$post_keys = $this->find_data($post_list, $keyword);
				break;
			case "author":
				$post_keys = $this->find_data($post_list, $keyword);
				break;
			default:
				$post_keys = $this->find_data($post_list, $keyword);
		}
		
		
		return $post_keys;
	}
	
	public function find_data(array $haystack, $needle,$column = array("slug","description"))
	{

		$return = array();
		
		foreach ($haystack as $key => $value) 
		{
			
			if(isset($colum["author"])){
				if (preg_match("/$needle/i",$value->user('username'))) {
					$return[] = $value->slug();
				}
			} else {
				
				if (preg_match("/$needle/i",$value->content())|| preg_match("/$needle/i",$value->slug())) {
					$return[] = $value->slug();
				}				
			}
		}
		return $return;
	}

}